<?php
/* This file converts the quality check XML to HTML
   (C) 2006 Andras Mantia <amantia@kde.org>
   Licenced under General Public Licence, V2
*/ 

$completecFound = false;
$notapplicableFound = false;
$criteriaindex = 0;
$componentindex = 0;
$completedIndex = 0;
$notapplicableIndex = 0;

function startElement($parser, $name, $attrs) 
{
  global $criterias;
  global $criteriaindex;
  global $componentindex;
  global $components;
  global $completecFound;
  global $notapplicableFound;
  global $completedIndex;
  global $notapplicableIndex;
 
  if ($name=="criteria")
  {
    $criterias[$criteriaindex]["id"] = $attrs["id"];
    $criterias[$criteriaindex]["name"] = $attrs["name"];
  } else
  if ($name=="check")
  {
    $components[$componentindex]["name"] = $attrs["name"];
    $components[$componentindex]["module"] = $attrs["module"];
    $components[$componentindex]["completed"][0] = "";
    $components[$componentindex]["notapplicable"][0] = "";
  } else
  if ($name=="completeditems")
  {
    $completecFound = true;
  } else
  if ($name=="notapplicableitems")
  {
    $notapplicableFound = true;
  } else
  if ($name=="item")
  {
    if ($completecFound)
    {
      $components[$componentindex]["completed"][$completedIndex] = $attrs["id"];
    } else
    if ($notapplicableFound)
    {
      $components[$componentindex]["notapplicable"][$notapplicableIndex] = $attrs["id"];
    }
  }
}

function endElement($parser, $name) 
{
  global $criteriaindex;
  global $componentindex;
  global $completecFound;
  global $completedIndex;
  global $notapplicableFound;
  global $notapplicableIndex;

  if ($name=="criteria")
  {
    $criteriaindex++;
  } else
  if ($name=="check")
  {
    $componentindex++;
    $completecFound = false;
    $completedIndex = 0;
    $notapplicableFound = false;
    $notapplicableIndex = 0;
  } else
  if ($name=="completeditems")
  {
    $completecFound = false;
  } else
  if ($name=="notapplicableitems")
  {
    $notapplicableFound = false;
  } else
  if ($name == "item")
  {
    if ($completecFound)
    {
      $completedIndex++;
    } else
    if ($notapplicableFound)
    {
      $notapplicableIndex++;
    }
  }
}

function characterData($parser, $data) 
{

}

function readXML($fileName)
{
  $xml_parser = xml_parser_create();
  xml_parser_set_option($xml_parser, XML_OPTION_CASE_FOLDING, false);
  xml_set_element_handler($xml_parser, "startElement", "endElement");
  xml_set_character_data_handler($xml_parser, "characterData");
  if (!($fp = fopen($fileName, "r"))) 
  {
    die("could not open XML input");
  }

//read the XML file and build the arrays
  while ($data = fread($fp, 4096)) {
      if (!xml_parse($xml_parser, $data, feof($fp))) {
          die(sprintf("XML error: %s at line %d",
                      xml_error_string(xml_get_error_code($xml_parser)),
                      xml_get_current_line_number($xml_parser)));
      }
  }
  xml_parser_free($xml_parser);
}

function show($application)
{
  global $criterias;
  global $components;

//only for debugging
/*
  print "Criterias:<br />";
  foreach ($criterias as $criteria)
  {
    print("Name: ".$criteria["name"]." id: ".$criteria["id"]. "<br />");
  }
  print "<br />";*/
  foreach ($components as $component)
  {
    print "Result for <strong>".$component["name"]."</strong> from module <em>".$component["module"]."</em>:<br />";
    print "<ul>";
    foreach ($criterias as $criteria)
    {
      print "<li><em>".$criteria["name"]."</em>: <strong>";
      if (in_array($criteria["id"], $component["completed"]))
      {
        print "passed";
      } else    
      if (in_array($criteria["id"], $component["notapplicable"]))
      {
        print "N/A";
      } else
      {
        print "not passed";
      }
      print "</strong></li>";
    }
    
    print "</ul><br />";
  }
}
  
/*

  global $answers;
  global $questions;
  global $ids;
  
  $found = false;   
  foreach ($questions as $question)
  {
    if ($question["app"] == $application || ($question["app"] == "common" && $showcommon) || $application == "")
    {
      $found = true;
      break;
    }
  }
  if ($found == false)
    return;
//create the section with the questions
$text = <<<TEXT
  <div class="inMain hatch" >
    <div class="mainHead">FAQs. </div>
    <dl>
      <dd> 
TEXT;
  print $text;
  $i = 1;
  foreach ($questions as $question)
  {
    if ($question["app"] == $application || ($question["app"] == "common" && $showcommon) || $application == "")
    {
      print $i.". <a href=\"#".$question["id"]."\">".$question["text"]."</a><br />";
      $i++;
    }
  }
  print "</dd></dl></div>";
  

  $count = count($questions);
  $j = 1;
  for ($i=0; $i < $count; $i++) 
  {
    $question = $questions[$i];
    if ($question["app"] == $application || ($question["app"] == "common" && $showcommon) || $application == "")
    {
      print "<div class=\"inMain hatch\" >\n";
      print "<div class=\"mainHead\"><a name=\"".$question["id"]."\"></a>".$question["text"]."</div>\n";
      print "<dl><dd>\n";
      print $answers[$i]."<br />\n";
  //    print "<dt><br /><em>Contributed by ".$question["name"]." &lt;<a href=\"mailto:".$question["email"]."\">".$question["email"]."</a>&gt;.</em><br />";
      print "<br /><a href=\"#top\">[return to top]</a>\n";
      print "</dd></dl></div>\n";  
      $j++;
    }
  }
}*/
?>
